#include <stddef.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <dirent.h>
#include <stdlib.h>
#include <libgreattao/tao.h>
#include "dir.h"

void free_files(struct view *view)
{
  struct file *curr_ = view->files;
  struct file *next_;
  char *buffer;
  int   length;
  
  view->files = NULL;
  view->selected = NULL;
  
  while (curr_) {
    
    next_ = curr_->next_file;
    free((void*)curr_->tao_path);
    free((void*)curr_->name);
    free(curr_);
    curr_ = next_;
  }
  
  length = strlen(view->tao_path) + strlen("/list/items/");
  buffer = malloc(length + 1);
  strcpy(buffer, view->tao_path);
  strcat(buffer, "/list/items/");
  tao_delete_handlers(get_main_window(), buffer);
  free(buffer);
}

void file_selected(void *mesh, struct file *file)
{
  file->view->selected = file;
  set_active_view(file->view);
}

int load_directory(struct view *view, const char *location)
{
  const char *old_path;
  char *buffer;
  char size_buffer[20];
  int length1, length2, length3;
  int length_base, length_max;
  int location_size;
  int name_size;
  char *path_to_file;
  DIR *dir;
  struct dirent *dirent;
  struct file *curr_;
  struct stat file_stat;
  

  dir = opendir(location);
  
  if (!dir) {
  
    return 0;
  }
  
  old_path = view->dir_path;
  view->dir_path = strdup(location);
  location_size = strlen(view->dir_path);
  if (old_path) {
    
    free((void*)old_path);
  }
  if (view->files) {
  
    free_files(view);
  }
  
  while (dirent = readdir(dir)) {
  
    if (strcmp(dirent->d_name, ".") == 0 || strcmp(dirent->d_name, "..") == 0) {
    
      continue;
    }
    length_base = strlen(view->tao_path) + strlen("/list/items/") + strlen(dirent->d_name);
    length1 = length_base + strlen("/data/name");
    length2 = length_base + strlen("/data/size");
    length3 = length_base + strlen("/selected");
    
    length_max = length1;
    if (length_max < length2) {
      
      length_max = length2;
    }
    if (length_max < length3) {
      
      length_max = length3;
    }
    
    name_size = strlen(dirent->d_name);
    path_to_file = (char *) malloc(location_size + name_size + 2);
    strcpy(path_to_file, view->dir_path);
    strcat(path_to_file, "/");
    strcat(path_to_file, dirent->d_name);
    
    curr_ = (struct file*) malloc(sizeof(*curr_));
    
    buffer = (char*) malloc(length_max + 1);
    strcpy(buffer, view->tao_path);
    strcat(buffer, "/list/items/");
    strcat(buffer, dirent->d_name);
    tao_add_handler(get_main_window(), buffer, NULL, 0);
    curr_->name = strdup(dirent->d_name);
    curr_->view = view;
    curr_->tao_path = strdup(buffer);
    curr_->next_file = view->files;
    view->files = curr_;

    strcpy(&buffer[length_base], "/data/name");
    tao_add_handler(get_main_window(), buffer, NULL, 0);
    tao_set_hint(get_main_window(), buffer, 0, dirent->d_name);
    
    strcpy(&buffer[length_base], "/data/size");
    tao_add_handler(get_main_window(), buffer, NULL, 0);
    
    
    if (stat(path_to_file, &file_stat) == 0) {
      
      snprintf(size_buffer, 20, "%d bytes", file_stat.st_size);
      tao_set_hint(get_main_window(), buffer, 0, size_buffer);
    }
    
    strcpy(&buffer[length_base], "/selected");
    tao_add_handler(get_main_window(), buffer, file_selected, curr_);
    
    free(buffer);
    free(path_to_file);
  }
  
  closedir(dir);
  return 1;
}